$regfile = "m8def.dat"                                      '8
$crystal = 10000000                                         '10



'     
Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Portd.6 , E = Portd.5 , Db4 = Portb.1 , Db5 = Portb.0 , Db6 = Portb.2 , Db7 = Portd.7
Cursor Off
Cls

'  

Deflcdchar 0 , 28 , 20 , 28 , 32 , 32 , 32 , 32 , 32        ' 
Deflcdchar 1 , 32 , 4 , 14 , 14 , 29 , 29 , 31 , 14         '
Deflcdchar 2 , 14 , 10 , 10 , 10 , 14 , 31 , 31 , 14        '


'  

' 
Declare Sub Get_th(t As Byte , H As Byte)

Config Serialin = Buffered , Size = 128
Config Serialout = Buffered , Size = 128

'   PortC.2
Dht_put Alias Portc.2
Dht_get Alias Pinc.2
Dht_io_set Alias Ddrc.2

Dim T As Byte                                               ' 
Dim H As Byte                                               ' 
Dim Crc As Byte                                             '    
Dim Mybyte As Byte
Dim Sensor_data As String * 40                              '     
Dim Tmp_str8 As String * 8
Dim Count As Byte                                           '    

Set Dht_io_set
Set Dht_put

'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
'  

'  
Config Portc.4 = Output                                     '  
Config Portc.5 = Output                                     '  

Rele1 Alias Portc.4                                         '  1,   
Rele2 Alias Portc.5                                         '  2,    

Rele2 = 1

Config Portc.3 = Output                                     '  
Led Alias Portc.3

Config Portd.0 = Output                                     '    
Ledred Alias Portd.0

Config Portd.1 = Output                                     ' 
Backlight Alias Portd.1



Config Timer1 = Timer , Prescale = 1024
On Timer1 Overflow:
Stop Timer1


'  
Config Int0 = Falling
Config Int1 = Falling

Config Portd.4 = Input                                      '    

On Int0 Button                                              '   
On Int1 Encod                                               '   


'   
Dim A As Byte

'      
Dim Hum_eeprom As Eram Byte                                 '    
Dim Temp_eeprom As Eram Byte                                '    

Dim Temp As Byte                                            '    
Dim Hum As Byte                                             '    

Dim Tdispl As Byte                                          '   
Dim Hdispl As Byte                                          '   
Dim Tsave As Byte                                           '    
Dim Hsave As Byte                                           '    

Dim Error As Byte                                           '   

Hum = Hum_eeprom                                            '  
Temp = Temp_eeprom                                          '   


Dim Flag1 As Bit                                            '   
Dim Flag2 As Bit                                            '   
Dim Ttemp As Byte                                           '   
Dim Htemp As Byte                                           '   

Cls
Backlight = 1                                               '  

'   :)
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0
Waitms 60
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0


'      
'      
Cls
Lcd "AVRproject.ru"
Lowerline
Lcd "ver. 25/05/12"
Wait 7
Cls




                   '     
'#####################################################################################
Rem  
Lcd "TECT HAPEBATE"
Rele1 = 1
Wait 3
Rele1 = 0
Waitms 800

Cls

Rem  
Lcd "TECT BEHTᥥ"
Rele2 = 1
Wait 2
Rele2 = 0
Waitms 200
Cls

Cls

Rem 
Rem :
Lcd "caoea"
Lowerline
Lcd "eepaypa:"
Locate 2 , 14
Lcd Temp ; Chr(0) ; "C"

Wait 2
Cls

Rem 
Rem :
Lcd "caoea"
Lowerline
Lcd "aoc:"
Locate 2 , 12
Lcd Hum ; "%"

Wait 2
Cls

'#####################################################################################
                        '  


'    
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0
Waitms 60
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0


' 
Enable Interrupts
Enable Int0
Enable Int1
Enable Timer1

                             ' 
'================================================================================================
Backlight = 0                                               ' 


Do

Disable Interrupts
Call Get_th(t , H)                                          '   
Gosub Compare                                               '      
Enable Interrupts

If A = 0 Then                                               '   
    Cls

  If H = 111 Then                                           '  ,        
    Ledred = 1
    Lcd "Sensor"
    Lowerline
    Lcd "not respond"
  Elseif H = 222 Then
    Ledred = 1
    Lcd "Sensor"
    Lowerline
    Lcd "is incorrect"
  Elseif H = 123 Then
    Ledred = 1
    Lcd "CRC error"
    Lowerline
    Lcd "sensor is broken"

  Else

    Ledred = 0
    Lcd "Temp: " ; T ; "C"
     If Flag1 = 1 Then
     Locate 1 , 16
     Lcd Chr(2)                                             '    
     End If
    Lowerline
    Lcd "Hmdt: " ; H ; "%"
     If Flag2 = 1 Then
     Locate 2 , 16
     Lcd Chr(1)
     End If
    Led = 1
    Waitms 10
    Led = 0
    Wait 3

   End If
  Wait 1
End If


If A = 1 Then
    Timer1 = 0
     Do
     Cls
     ' 
     Lcd "opo T"
     Lowerline
     Lcd Tdispl ; Chr(0) ; "C"
     Waitms 400
 Loop Until A <> 1
End If


 If A = 2 Then
    Timer1 = 0
    Do
     Cls
     ' H
     Lcd "opo H"
     Lowerline
     Lcd Hdispl ; "%"
     Waitms 400
    Loop Until A <> 2
End If



Loop



                         '   DHT11
'**************************************************************************************************

Sub Get_th(t As Byte , H As Byte)

 Count = 0
 Sensor_data = ""
 Set Dht_io_set                                             ' PD.6 
 Reset Dht_put                                              '   
 Waitms 25                                                  '   18

 Set Dht_put                                                ' 
 Waitus 40
 Reset Dht_io_set                                           ' PD.6 
 Waitus 40                                                  ' 40 
 If Dht_get = 1 Then                                        '     1
    Error = 1                                               '   ,   
    H = 111

    Exit Sub                                                '  
 End If

'         
  Waitus 80                                                 '  80 
  If Dht_get = 0 Then                                       '     0
    Error = 2                                               '    
    H = 222

    Exit Sub                                                '  
  End If

'      ,  

  While Dht_get = 1 : Wend                                  '     1

   Do                                                       '  40  
    While Dht_get = 0 : Wend                                '    0
    Waitus 30                                               '  0  30
     If Dht_get = 1 Then                                    '   1
       Sensor_data = Sensor_data + "1"                      '    
       While Dht_get = 1 : Wend                             '      
       Else                                                 ',    0
       Sensor_data = Sensor_data + "0"                      '  0  
    End If
    Incr Count                                              '   1
   Loop Until Count = 40                                    '      40

   Set Dht_io_set
   Set Dht_put

'   

   Tmp_str8 = Left(sensor_data , 8)                         '  8  
   H = Binval(tmp_str8)                                     '   

   Tmp_str8 = Mid(sensor_data , 17 , 8)                     ' 8   
   T = Binval(tmp_str8)                                     '   

   Tmp_str8 = Right(sensor_data , 8)                        ' 8 
   Crc = Binval(tmp_str8)                                   ' 

'  

   Mybyte = T + H                                           '    
   If Mybyte <> Crc Then                                    '    
      Error = 3                                             '    
      H = 123
   End If

End Sub                                                     '    









                           '   
'**************************************************************************************************

Overflow:
 Stop Timer1                                                '   
 Timer1 = 0
 A = 0                                                      ' 
 Backlight = 0                                              ' 
Return





                       '/ 
'**************************************************************************************************
Compare:                                                    '   / 

 If H = 111 Or H = 222 Or H = 123 Then                      '        
   Rele1 = 0
   Rele2 = 0
   Goto Extcompare
 End If


If Flag1 = 0 Then                                           ' 1  
  If T < Temp Then                                          '    
  Rele1 = 1                                                 ' 
  Flag1 = 1                                                 ' 
  End If
End If

If Flag1 = 1 Then                                           '   1,  
  Ttemp = Temp + 1                                          '  1 
  If T >= Ttemp Then                                        '  
   Rele1 = 0                                                ' 
   Flag1 = 0                                                '  
  End If
End If

'    
If Flag2 = 0 Then
  If H > Hum Then                                           '    
  Rele2 = 0                                                 ' 
  Flag2 = 1
  End If
End If

If Flag2 = 1 Then
  Htemp = Hum - 1
  If H =< Htemp Then
   Rele2 = 1
   Flag2 = 0
  End If
End If

Extcompare:

Return






                       '  
'**************************************************************************************************
Encod:

 Backlight = 1                                              '  
 Stop Timer1
 Timer1 = 0
 Start Timer1


 If A > 0 Then
  Waitms 2                                                  '    
  If Pind.3 = 0 Then
   If Pind.4 = 0 Then                                       '    (  ) 

    If A = 1 Then
     Incr Tdispl
       If Tdispl > 100 Then
        Tdispl = 100
       End If

    End If

    If A = 2 Then
     Incr Hdispl

      If Hdispl > 100 Then
        Hdispl = 100
       End If

    End If

   Else

    If A = 1 Then
     Decr Tdispl
     If Tdispl > 200 Then
      Tdispl = 0
     End If

    End If

    If A = 2 Then
     Decr Hdispl

     If Hdispl > 200 Then
      Hdispl = 0
     End If

    End If


   End If
  End If
 Gifr = 128                                                 '    INT1
 End If


Return




Button:                                                     ' 

 Timer1 = 0                                                 ' 
 Start Timer1                                               ' 
 Backlight = 1                                              '  
'  , no comments ;)
   If A = 2 Then
    A = 0

    '          
    If Tdispl <> Temp Then
        Temp = Tdispl
        Temp_eeprom = Temp
        Cls
        ' 
        Lcd "Te. acaa"
         Ledred = 1
         Waitms 50
         Ledred = 0
        Wait 1

    End If

    If Hdispl <> Hum Then
       Hum = Hdispl
       Hum_eeprom = Hum
       Cls
       ' 
       Lcd "Ba. acaa"
        Ledred = 1
        Waitms 50
        Ledred = 0

       Wait 1

    End If
      Waitms 30
      Gifr = 64

       Sound , Portb.3 , 600 , 500
      Goto Argh                                             '   ,    

  End If


   Sound , Portb.3 , 200 , 500

   If A = 1 Then
    A = 2
    Hdispl = Hum
   End If

   If A = 0 Then
    A = 1
    Tdispl = Temp
   End If



Argh:
 Ledred = 1
 Waitms 30
 Ledred = 0

 Waitms 50                                                  '  
 Gifr = 64                                                  '   

Return


End